<?php
include_once("data_db.php");
include_once("device_db.php");

function api_replace_data_DS($hostId, $template_id, $snmpFieldName, $snmpValueName, $data_source_path, &$errors){
	$template = getGraphTemplateByID($template_id, $errors);

	if (!empty($errors)) {
		catchException("", "", "api_replace_data_DS", "Error in main function", $errors);
		return 1;
	}
	//data_template_data.id, data_template_data.data_source_path, host.hostname, data_template.id, host_snmp_cache.field_name, host_snmp_cache.field_value
	$data_template_data = getDataSourceDS($hostId, $template_id, $snmpFieldName, $snmpValueName, $errors);

	if (!empty($errors)) {
		catchException("", "data_template_data", "api_replace_data_DS", "RRD file phisicaly not exist", $errors);
		return 1;
	}
	// check this $data_template_data["data_template_data.id"]
	updateDataSourceDS($data_source_path, $data_template_data["id"], $errors);
	
	if (!empty($errors)) {
		catchException("", "", "api_replace_data_DS", "Error in main function", $errors);
		return 1;
	}
	return $data_template_data;
}

function api_get_data_DS($hostId, $template_id, $snmpFieldName, $snmpValueName, &$errors){
	$template = getGraphTemplateByID($template_id, $errors);

	if (!empty($errors)) {
		catchException("", "", "api_get_data_DS", "Error in main function", $errors);
		return 1;
	}
	//data_template_data.id, data_template_data.data_source_path, host.hostname, data_template.id, host_snmp_cache.field_name, host_snmp_cache.field_value
	$data_template_data = getDataSourceDS($hostId, $template_id, $snmpFieldName, $snmpValueName, $errors);
	if (!empty($errors)) {
		catchException("", "data_template_data", "api_get_data_DS", "Error in main function", $errors);
		return 1;
	}
	return $data_template_data;
}

function api_replace_rrd_file_DS($hostId, $template_id, $snmpFieldName, $snmpValueName, $old_data_source_path, $old_data_source_file, &$errors){
	$template = getGraphTemplateByID($template_id, $errors);

	if (!empty($errors)) {
		catchException("", "", "api_replace_rrd_file_DS", "Error in main function", $errors);
		return 1;
	}

	$data_template_data = getDataSourceDS($hostId, $template_id, $snmpFieldName, $snmpValueName, $errors);

	if (!empty($errors)) {
		catchException("", "data_template_data", "api_replace_rrd_file_DS", "Error in main function", $errors);
		return 1;
	} else {
		$new_data_source_path = db_fetch_cell("SELECT data_template_data.data_source_path FROM data_template_data WHERE data_template_data.id = " . $data_template_data["id"]);

		preg_match("/(.+)\/(.+\.rrd)$/", $new_data_source_path, $matches);
		$matches[1] = ereg_replace("<path\_rra>", dirname(__FILE__). "/rra", $matches[1]);

		$command = dirname(__FILE__) . "/convertRRD.pl -or " . $old_data_source_file . " -nr " . $matches[2] . " -ds ds0:traffic_in -ds ds1:traffic_out -od " . $old_data_source_path . " -nd " . $matches[1] . " -b -f ";

		$last_line = system($command, $resoultExec);

		$returnResult["last_line"] = $last_line;
		$returnResult["resoult_exec"] = $resoultExec;
		return $returnResult;
	}
}

?>